#include <stdio.h>
#include "magic.h"

#define ITERATIONS 1
#define NUM_FUNCS 2
#define NUMROWS 512
#define NUMCOLS 16
#define STAT_SIZE ITERATIONS*NUM_FUNCS
#define COL_START 0
#define COL_END NUMCOLS-1
#define ROW_START1 0
#define ROW_START2 128
#define ROW_START3 256
#define ROW_END1 255
#define ROW_END2 383
#define ROW_END3 511
// data

#define eventSumColItoJForRowsLtoH(L, H) \
{ \
    int r; \
    for (r = L; r <= H; r++) { \
        sum += globalArray[r][0]; \
    } \
}

int main() {
    int globalArray[NUMROWS][NUMCOLS];
    int sum;

	int i;
	simicsBreakpoint();

	// First init (may need to be changed for diff runs)
	eventSumColItoJForRowsLtoH(ROW_START1,ROW_END3);

	simicsBreakpoint();

	// First test
	/* all A, all B, all C*/
	for (i = 0; i < ITERATIONS; i++) {
		eventSumColItoJForRowsLtoH(ROW_START1,ROW_END1);
	}
	for (i = 0; i < ITERATIONS; i++) {
		eventSumColItoJForRowsLtoH(ROW_START2,ROW_END2);
	}
	for (i = 0; i < ITERATIONS; i++) {
		eventSumColItoJForRowsLtoH(ROW_START3,ROW_END3);
	}

	simicsBreakpoint();

	// Second init (may need to be changed for diff runs)
    eventSumColItoJForRowsLtoH(ROW_START1,ROW_END3);

	simicsBreakpoint();

	// Second test
	/* ABCABC... */
	for (i = 0; i < ITERATIONS; i++) {
        eventSumColItoJForRowsLtoH(ROW_START1,ROW_END1);
        eventSumColItoJForRowsLtoH(ROW_START2,ROW_END2);
        eventSumColItoJForRowsLtoH(ROW_START3,ROW_END3);
	}

	simicsBreakpoint();

    printf("sum = %d \n", sum);
	
	return 0;
}

